<template>
  <!-- Начало шаблона Vue -->
  <q-list>
    <!-- Компонент списка Quasar -->
    <q-item
      v-for="(item, index) in items"
      :key="item.id"
      v-touch-pan="handlePan($event, index)"
      :style="getItemStyle(index)"
    >
      <!-- Элемент списка с обработчиком свайпа и динамическим стилем -->
      {{ item.name }}
      <!-- Отображение названия элемента -->
    </q-item>
  </q-list>
</template>

<script lang="ts">
import { defineComponent, ref } from 'vue';

export default defineComponent({
  // Объявление компонента с использованием TypeScript
  setup() {
    // Функция setup для состояния и логики компонента
    const items = ref([
      { id: 1, name: 'Item 1' },
      { id: 2, name: 'Item 2' },
    ]);
    // Состояние списка элементов
    const swipeOffset = ref<{ [key: number]: number }>({});
    // Объект для хранения смещения свайпа для каждого элемента

    const handlePan = (event: any, index: number): any => {
      // Метод обработки свайпа
      if (event.isFinal) {
        // Проверка, завершён ли свайп
        if (Math.abs(event.distance.x) > 100) {
          // Проверка, достаточно ли далеко сдвинут элемент
          items.value.splice(index, 1);
          // Удаление элемента, если свайп достаточно большой
        } else {
          swipeOffset.value[index] = 0;
          // Возврат элемента на место, если свайп недостаточно большой
        }
      } else {
        swipeOffset.value[index] = event.distance.x;
        // Обновление смещения свайпа в реальном времени
      }
    };

    const getItemStyle = (index: number) => {
      // Метод для получения стиля элемента
      const offset = swipeOffset.value[index] || 0;
      // Получение текущего смещения для элемента
      return {
        transform: `translateX(${offset}px)`,
        transition: 'transform 0.2s ease-in-out',
        // Применение смещения и анимации к элементу
      };
    };

    return { items, handlePan, getItemStyle };
    // Возвращение состояния и методов для шаблона
  },
});
</script>

<style>
/* Дополнительные стили при необходимости */
</style>
